Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/AnalyticalPTSP.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/AnalyticalPTSP.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/AnalyticalPTSP.cs	(revision 17253)
@@ -20,25 +20,20 @@
 #endregion
 
-using System;
 using System.Linq;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Encodings.PermutationEncoding;
-using HeuristicLab.Optimization;
-using HEAL.Attic;
 
 namespace HeuristicLab.Problems.PTSP {
-  [Item("Analytical Probabilistic Traveling Salesman Problem (PTSP)", "Represents a probabilistic traveling salesman problem where the expected tour length is calculated exactly.")]
+  [Item("Analytical Probabilistic TSP (p-TSP)", "Represents a probabilistic traveling salesman problem where the expected tour length is calculated exactly.")]
   [Creatable(CreatableAttribute.Categories.CombinatorialProblems)]
   [StorableType("509B6AB5-F4DE-4144-A031-43EEBAD02CA6")]
-  public sealed class AnalyticalProbabilisticTravelingSalesmanProblem : ProbabilisticTravelingSalesmanProblem {
+  public sealed class AnalyticalPTSP : ProbabilisticTSP {
 
     [StorableConstructor]
-    private AnalyticalProbabilisticTravelingSalesmanProblem(StorableConstructorFlag _) : base(_) { }
-    private AnalyticalProbabilisticTravelingSalesmanProblem(AnalyticalProbabilisticTravelingSalesmanProblem original, Cloner cloner) : base(original, cloner) { }
-    public AnalyticalProbabilisticTravelingSalesmanProblem() {
-      Operators.Add(new BestPTSPSolutionAnalyzer());
-
+    private AnalyticalPTSP(StorableConstructorFlag _) : base(_) { }
+    private AnalyticalPTSP(AnalyticalPTSP original, Cloner cloner) : base(original, cloner) { }
+    public AnalyticalPTSP() {
       Operators.Add(new PTSPAnalyticalInversionMoveEvaluator());
       Operators.Add(new PTSPAnalyticalInsertionMoveEvaluator());
@@ -53,8 +48,4 @@
       Operators.Add(new PTSPAnalyticalTwoPointFiveMoveEvaluator());
 
-      Operators.RemoveAll(x => x is SingleObjectiveMoveGenerator);
-      Operators.RemoveAll(x => x is SingleObjectiveMoveMaker);
-      Operators.RemoveAll(x => x is SingleObjectiveMoveEvaluator);
-
       Encoding.ConfigureOperators(Operators.OfType<IOperator>());
       foreach (var twopointfiveMoveOperator in Operators.OfType<ITwoPointFiveMoveOperator>()) {
@@ -64,21 +55,19 @@
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      return new AnalyticalProbabilisticTravelingSalesmanProblem(this, cloner);
+      return new AnalyticalPTSP(this, cloner);
     }
 
     public override double Evaluate(Permutation tour, IRandom random) {
-      // abeham: Cache in local variable for performance reasons
-      var distanceMatrix = DistanceMatrix;
-      return Evaluate(tour, (a, b) => distanceMatrix[a, b], Probabilities);
+      return Evaluate(tour, ProbabilisticTSPData);
     }
 
-    public static double Evaluate(Permutation tour, Func<int, int, double> distance, DoubleArray probabilities) {
+    public static double Evaluate(Permutation tour, IProbabilisticTSPData data) {
       // Analytical evaluation
       var firstSum = 0.0;
       for (var i = 0; i < tour.Length - 1; i++) {
         for (var j = i + 1; j < tour.Length; j++) {
-          var prod1 = distance(tour[i], tour[j]) * probabilities[tour[i]] * probabilities[tour[j]];
+          var prod1 = data.GetDistance(tour[i], tour[j]) * data.GetProbability(tour[i]) * data.GetProbability(tour[j]);
           for (var k = i + 1; k < j; k++) {
-            prod1 = prod1 * (1 - probabilities[tour[k]]);
+            prod1 *= (1 - data.GetProbability(tour[k]));
           }
           firstSum += prod1;
@@ -88,10 +77,10 @@
       for (var j = 0; j < tour.Length; j++) {
         for (var i = 0; i < j; i++) {
-          var prod2 = distance(tour[j], tour[i]) * probabilities[tour[i]] * probabilities[tour[j]];
+          var prod2 = data.GetDistance(tour[j], tour[i]) * data.GetProbability(tour[i]) * data.GetProbability(tour[j]);
           for (var k = j + 1; k < tour.Length; k++) {
-            prod2 = prod2 * (1 - probabilities[tour[k]]);
+            prod2 *= (1 - data.GetProbability(tour[k]));
           }
           for (var k = 0; k < i; k++) {
-            prod2 = prod2 * (1 - probabilities[tour[k]]);
+            prod2 *= (1 - data.GetProbability(tour[k]));
           }
           secondSum += prod2;
@@ -100,8 +89,4 @@
       return firstSum + secondSum;
     }
-
-    public static double Evaluate(Permutation tour, DistanceMatrix distanceMatrix, DoubleArray probabilities) {
-      return Evaluate(tour, (a, b) => distanceMatrix[a, b], probabilities);
-    }
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/EstimatedPTSP.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/EstimatedPTSP.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/EstimatedPTSP.cs	(revision 17253)
@@ -21,53 +21,57 @@
 
 using System;
+using System.Collections.Generic;
 using System.Linq;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
 using HeuristicLab.Encodings.PermutationEncoding;
-using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
-using HeuristicLab.Problems.Instances;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.PTSP {
-  [Item("Estimated Probabilistic Traveling Salesman Problem (PTSP)", "Represents a probabilistic traveling salesman problem where the expected tour length is estimated by averaging over the length of tours on a number of, so called, realizations.")]
+  [Item("Estimated Probabilistic TSP (p-TSP)", "Represents a probabilistic traveling salesman problem where the expected tour length is estimated by averaging over the length of tours on a number of, so called, realizations.")]
   [Creatable(CreatableAttribute.Categories.CombinatorialProblems)]
-  [StorableType("D1F1DE71-54E3-40B6-856F-685CD71D97F9")]
-  public sealed class EstimatedProbabilisticTravelingSalesmanProblem : ProbabilisticTravelingSalesmanProblem {
+  [StorableType("d1b4149b-8ab9-4314-8d96-9ea04a4d5b8b")]
+  public sealed class EstimatedPTSP : ProbabilisticTSP {
 
     #region Parameter Properties
-    public IValueParameter<ItemList<BoolArray>> RealizationsParameter {
-      get { return (IValueParameter<ItemList<BoolArray>>)Parameters["Realizations"]; }
-    }
-    public IFixedValueParameter<IntValue> RealizationsSizeParameter {
-      get { return (IFixedValueParameter<IntValue>)Parameters["RealizationsSize"]; }
-    }
+    [Storable] public IFixedValueParameter<IntValue> RealizationsSeedParameter { get; private set; }
+    [Storable] public IFixedValueParameter<IntValue> RealizationsParameter { get; private set; }
+    [Storable] private IValueParameter<ReadOnlyItemList<BoolArray>> RealizationDataParameter { get; set; }
     #endregion
 
     #region Properties
-    public ItemList<BoolArray> Realizations {
-      get { return RealizationsParameter.Value; }
-      set { RealizationsParameter.Value = value; }
-    }
-
-    public int RealizationsSize {
-      get { return RealizationsSizeParameter.Value.Value; }
-      set { RealizationsSizeParameter.Value.Value = value; }
+
+    public int RealizationsSeed {
+      get { return RealizationsSeedParameter.Value.Value; }
+      set { RealizationsSeedParameter.Value.Value = value; }
+    }
+
+    public int Realizations {
+      get { return RealizationsParameter.Value.Value; }
+      set { RealizationsParameter.Value.Value = value; }
+    }
+    
+    private ReadOnlyItemList<BoolArray> RealizationData {
+      get { return RealizationDataParameter.Value; }
+      set { RealizationDataParameter.Value = value; }
     }
     #endregion
 
     [StorableConstructor]
-    private EstimatedProbabilisticTravelingSalesmanProblem(StorableConstructorFlag _) : base(_) { }
-    private EstimatedProbabilisticTravelingSalesmanProblem(EstimatedProbabilisticTravelingSalesmanProblem original, Cloner cloner)
+    private EstimatedPTSP(StorableConstructorFlag _) : base(_) { }
+    private EstimatedPTSP(EstimatedPTSP original, Cloner cloner)
       : base(original, cloner) {
+      RealizationsSeedParameter = cloner.Clone(original.RealizationsSeedParameter);
+      RealizationsParameter = cloner.Clone(original.RealizationsParameter);
+      RealizationDataParameter = cloner.Clone(original.RealizationDataParameter);
       RegisterEventHandlers();
     }
-    public EstimatedProbabilisticTravelingSalesmanProblem() {
-      Parameters.Add(new FixedValueParameter<IntValue>("RealizationsSize", "Size of the sample for the estimation-based evaluation", new IntValue(100)));
-      Parameters.Add(new ValueParameter<ItemList<BoolArray>>("Realizations", "The list of samples drawn from all possible stochastic instances.", new ItemList<BoolArray>()));
-
-      Operators.Add(new BestPTSPSolutionAnalyzer());
+    public EstimatedPTSP() {
+      Parameters.Add(RealizationsSeedParameter = new FixedValueParameter<IntValue>("RealizationsSeed", "The starting seed of the RNG from which realizations should be drawn.", new IntValue(1)));
+      Parameters.Add(RealizationsParameter = new FixedValueParameter<IntValue>("Realizations", "The number of realizations that should be made.", new IntValue(100)));
+      Parameters.Add(RealizationDataParameter = new ValueParameter<ReadOnlyItemList<BoolArray>>("RealizationData", "The actual realizations.") { Hidden = true, GetsCollected = false });
 
       Operators.Add(new PTSPEstimatedInversionMoveEvaluator());
@@ -83,8 +87,4 @@
       Operators.Add(new PTSPEstimatedTwoPointFiveMoveEvaluator());
 
-      Operators.RemoveAll(x => x is SingleObjectiveMoveGenerator);
-      Operators.RemoveAll(x => x is SingleObjectiveMoveMaker);
-      Operators.RemoveAll(x => x is SingleObjectiveMoveEvaluator);
-
       Encoding.ConfigureOperators(Operators.OfType<IOperator>());
       foreach (var twopointfiveMoveOperator in Operators.OfType<ITwoPointFiveMoveOperator>()) {
@@ -97,5 +97,9 @@
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      return new EstimatedProbabilisticTravelingSalesmanProblem(this, cloner);
+      return new EstimatedPTSP(this, cloner);
+    }
+
+    public override double Evaluate(Permutation tour, IRandom random) {
+      return Evaluate(tour, ProbabilisticTSPData, RealizationData);
     }
 
@@ -105,29 +109,14 @@
     }
 
-    private void RegisterEventHandlers() {
-      RealizationsSizeParameter.Value.ValueChanged += RealizationsSizeParameter_ValueChanged;
-    }
-
-    private void RealizationsSizeParameter_ValueChanged(object sender, EventArgs e) {
-      UpdateRealizations();
-    }
-
-    public override double Evaluate(Permutation tour, IRandom random) {
-      // abeham: Cache parameters in local variables for performance reasons
-      var realizations = Realizations;
-      var realizationsSize = RealizationsSize;
-      var useDistanceMatrix = UseDistanceMatrix;
-      var distanceMatrix = DistanceMatrix;
-      var distanceCalculator = DistanceCalculator;
-      var coordinates = Coordinates;
-
+    public static double Evaluate(Permutation tour, IProbabilisticTSPData data, IEnumerable<BoolArray> realizations) {
       // Estimation-based evaluation, here without calculating variance for faster evaluation
       var estimatedSum = 0.0;
-      for (var i = 0; i < realizations.Count; i++) {
+      var count = 0;
+      foreach (var r in realizations) {
         int singleRealization = -1, firstNode = -1;
-        for (var j = 0; j < realizations[i].Length; j++) {
-          if (realizations[i][tour[j]]) {
+        for (var j = 0; j < data.Cities; j++) {
+          if (r[tour[j]]) {
             if (singleRealization != -1) {
-              estimatedSum += useDistanceMatrix ? distanceMatrix[singleRealization, tour[j]] : distanceCalculator.Calculate(singleRealization, tour[j], coordinates);
+              estimatedSum += data.GetDistance(singleRealization, tour[j]);
             } else {
               firstNode = tour[j];
@@ -136,9 +125,9 @@
           }
         }
-        if (singleRealization != -1) {
-          estimatedSum += useDistanceMatrix ? distanceMatrix[singleRealization, firstNode] : distanceCalculator.Calculate(singleRealization, firstNode, coordinates);
-        }
-      }
-      return estimatedSum / realizationsSize;
+        if (singleRealization != -1)
+          estimatedSum += data.GetDistance(singleRealization, firstNode);
+        count++;
+      }
+      return estimatedSum / count;
     }
 
@@ -147,31 +136,21 @@
     /// </summary>
     /// <param name="tour">The tour between all cities.</param>
-    /// <param name="distanceMatrix">The distances between the cities.</param>
-    /// <param name="realizations">A sample of realizations of the stochastic instance</param>
+    /// <param name="data">The main parameters of the p-TSP.</param>
+    /// <param name="realizations">How many realizations to achieve.</param>
+    /// <param name="seed">The starting seed of generating the realizations.</param>
     /// <param name="variance">The estimated variance will be returned in addition to the mean.</param>
     /// <returns>A vector with length two containing mean and variance.</returns>
-    public static double Evaluate(Permutation tour, DistanceMatrix distanceMatrix, ItemList<BoolArray> realizations, out double variance) {
-      return Evaluate(tour, (a, b) => distanceMatrix[a, b], realizations, out variance);
-    }
-
-    /// <summary>
-    /// An evaluate method that can be used if mean as well as variance should be calculated
-    /// </summary>
-    /// <param name="tour">The tour between all cities.</param>
-    /// <param name="distance">A func that accepts the index of two cities and returns the distance as a double.</param>
-    /// <param name="realizations">A sample of realizations of the stochastic instance</param>
-    /// <param name="variance">The estimated variance will be returned in addition to the mean.</param>
-    /// <returns>A vector with length two containing mean and variance.</returns>
-    public static double Evaluate(Permutation tour, Func<int, int, double> distance, ItemList<BoolArray> realizations, out double variance) {
+    public static double Evaluate(Permutation tour, IProbabilisticTSPData data, IEnumerable<BoolArray> realizations, out double variance) {
       // Estimation-based evaluation
       var estimatedSum = 0.0;
-      var partialSums = new double[realizations.Count];
-      for (var i = 0; i < realizations.Count; i++) {
-        partialSums[i] = 0;
+      var partialSums = new List<double>();
+      var count = 0;
+      foreach (var r in realizations) {
+        var pSum = 0.0;
         int singleRealization = -1, firstNode = -1;
-        for (var j = 0; j < realizations[i].Length; j++) {
-          if (realizations[i][tour[j]]) {
+        for (var j = 0; j < data.Cities; j++) {
+          if (r[tour[j]]) {
             if (singleRealization != -1) {
-              partialSums[i] += distance(singleRealization, tour[j]);
+              pSum += data.GetDistance(singleRealization, tour[j]);
             } else {
               firstNode = tour[j];
@@ -181,43 +160,50 @@
         }
         if (singleRealization != -1) {
-          partialSums[i] += distance(singleRealization, firstNode);
-        }
-        estimatedSum += partialSums[i];
-      }
-      var mean = estimatedSum / realizations.Count;
+          pSum += data.GetDistance(singleRealization, firstNode);
+        }
+        estimatedSum += pSum;
+        partialSums.Add(pSum);
+        count++;
+      }
+      var mean = estimatedSum / count;
       variance = 0.0;
-      for (var i = 0; i < realizations.Count; i++) {
+      for (var i = 0; i < count; i++) {
         variance += Math.Pow((partialSums[i] - mean), 2);
       }
-      variance = variance / realizations.Count;
+      variance = variance / count;
       return mean;
     }
 
-    public override void Load(PTSPData data) {
-      base.Load(data);
+    private void RegisterEventHandlers() {
+      RealizationsParameter.Value.ValueChanged += RealizationsOnChanged;
+      RealizationsSeedParameter.Value.ValueChanged += RealizationsSeedOnChanged;
+    }
+
+    private void RealizationsSeedOnChanged(object sender, EventArgs e) {
       UpdateRealizations();
-
-      foreach (var op in Operators.OfType<IEstimatedPTSPOperator>()) {
-        op.RealizationsParameter.ActualName = RealizationsParameter.Name;
-      }
+    }
+
+    private void RealizationsOnChanged(object sender, EventArgs e) {
+      if (Realizations <= 0) Realizations = 1;
+      else UpdateRealizations();
     }
 
     private void UpdateRealizations() {
-      var realizations = new ItemList<BoolArray>(RealizationsSize);
-      var rand = new MersenneTwister();
-      for (var i = 0; i < RealizationsSize; i++) {
-        var newRealization = new BoolArray(Probabilities.Length);
-        var countOnes = 0;
-        do {
-          countOnes = 0;
-          for (var j = 0; j < Probabilities.Length; j++) {
-            newRealization[j] = Probabilities[j] < rand.NextDouble();
-            if (newRealization[j]) countOnes++;
+      var data = new List<BoolArray>(Realizations);
+      var rng = new FastRandom(RealizationsSeed);
+      for (var i = 0; i < Realizations; i++) {
+        var cities = 0;
+        var r = new bool[ProbabilisticTSPData.Cities];
+        for (var j = 0; j < ProbabilisticTSPData.Cities; j++) {
+          if (rng.NextDouble() < ProbabilisticTSPData.GetProbability(j)) {
+            r[j] = true;
+            cities++;
           }
-          // only generate realizations with at least 4 cities visited
-        } while (countOnes < 4 && Probabilities.Length > 3);
-        realizations.Add(newRealization);
-      }
-      Realizations = realizations;
+        }
+        if (cities > 0) {
+          data.Add(new BoolArray(r, @readonly: true));
+        }
+      }
+      RealizationData = (new ItemList<BoolArray>(data)).AsReadOnly();
     }
   }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/HeuristicLab.Problems.PTSP-3.3.csproj
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/HeuristicLab.Problems.PTSP-3.3.csproj	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/HeuristicLab.Problems.PTSP-3.3.csproj	(revision 17253)
@@ -144,4 +144,9 @@
       <Private>False</Private>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.TravelingSalesman\3.3\HeuristicLab.Problems.TravelingSalesman-3.3.csproj">
+      <Project>{d767c38d-8014-46b0-9a32-03a3aecce34a}</Project>
+      <Name>HeuristicLab.Problems.TravelingSalesman-3.3</Name>
+      <Private>False</Private>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Random\3.3\HeuristicLab.Random-3.3.csproj">
       <Project>{F4539FB6-4708-40C9-BE64-0A1390AEA197}</Project>
@@ -160,17 +165,8 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="PTSPData.cs" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
     <None Include="Plugin.cs.frame" />
     <Compile Include="AnalyticalPTSP.cs" />
-    <Compile Include="Analyzers\BestPTSPSolutionAnalyzer.cs" />
-    <Compile Include="DistanceCalculators\MaximumDistance.cs" />
-    <Compile Include="DistanceCalculators\ManhattanDistance.cs" />
-    <Compile Include="DistanceCalculators\GeoDistance.cs" />
-    <Compile Include="DistanceCalculators\DistanceCalculator.cs" />
-    <Compile Include="DistanceCalculators\AttDistance.cs" />
-    <Compile Include="DistanceCalculators\UpperEuclideanDistance.cs" />
-    <Compile Include="DistanceCalculators\RoundedEuclideanDistance.cs" />
-    <Compile Include="DistanceCalculators\EuclideanDistance.cs" />
-    <Compile Include="DistanceMatrix.cs" />
     <Compile Include="EstimatedPTSP.cs" />
     <Compile Include="Improvers\PTSPAnalyticalInsertionLocalImprovement.cs" />
@@ -199,5 +195,4 @@
     <Compile Include="Moves\TwoPointFiveOpt\TwoPointFiveMoveMaker.cs" />
     <Compile Include="Moves\TwoPointFiveOpt\TwoPointFiveMove.cs" />
-    <Compile Include="PathPTSPTour.cs" />
     <Compile Include="PTSP.cs" />
     <Compile Include="Plugin.cs" />
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/Improvers/PTSPAnalyticalInsertionLocalImprovement.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/Improvers/PTSPAnalyticalInsertionLocalImprovement.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/Improvers/PTSPAnalyticalInsertionLocalImprovement.cs	(revision 17253)
@@ -22,4 +22,5 @@
 using System;
 using System.Threading;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -29,5 +30,4 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
 
 namespace HeuristicLab.Problems.PTSP {
@@ -39,5 +39,5 @@
   /// </remarks>
   [Item("PTSP Analytical Insertion Local Improvement", "An operator that improves probabilistic traveling salesman solutions. The operator tries to improve the probabilistic traveling salesman solution by swapping two randomly chosen edges for a certain number of times.")]
-  [StorableType("D63C6CB3-A5EF-4270-A252-2F5EBF1ED163")]
+  [StorableType("5adca9d8-02b2-4937-9f79-a24d8ea8ea19")]
   public sealed class PTSPAnalyticalInsertionLocalImprovement : SingleSuccessorOperator, IAnalyticalPTSPOperator, ILocalImprovementOperator {
 
@@ -70,10 +70,6 @@
     }
 
-    public ILookupParameter<DistanceMatrix> DistanceMatrixParameter {
-      get { return (ILookupParameter<DistanceMatrix>)Parameters["DistanceMatrix"]; }
-    }
-
-    public ILookupParameter<DoubleArray> ProbabilitiesParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters["Probabilities"]; }
+    public ILookupParameter<IProbabilisticTSPData> ProbabilisticTSPDataParameter {
+      get { return (ILookupParameter<IProbabilisticTSPData>)Parameters["PTSP Data"]; }
     }
 
@@ -90,6 +86,5 @@
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality value of the assignment."));
       Parameters.Add(new LookupParameter<BoolValue>("Maximization", "True if the problem should be maximized or minimized."));
-      Parameters.Add(new LookupParameter<DistanceMatrix>("DistanceMatrix", "The matrix which contains the distances between the cities."));
-      Parameters.Add(new LookupParameter<DoubleArray>("Probabilities", "The list of probabilities of the cities to appear."));
+      Parameters.Add(new LookupParameter<IProbabilisticTSPData>("PTSP Data", "The main parameters of the p-TSP."));
     }
 
@@ -98,7 +93,5 @@
     }
 
-    public static void Improve(Permutation assignment, DoubleMatrix distances, DoubleValue quality, IntValue localIterations, IntValue evaluatedSolutions, bool maximization, int maxIterations, DoubleArray probabilities, CancellationToken cancellation) {
-      var distanceM = (DistanceMatrix)distances;
-      Func<int, int, double> distance = (a, b) => distanceM[a, b];
+    public static void Improve(Permutation assignment, IProbabilisticTSPData data, DoubleValue quality, IntValue localIterations, IntValue evaluatedSolutions, bool maximization, int maxIterations, CancellationToken cancellation) {
       for (var i = localIterations.Value; i < maxIterations; i++) {
         TranslocationMove bestMove = null;
@@ -106,5 +99,5 @@
         var evaluations = 0.0;
         foreach (var move in ExhaustiveInsertionMoveGenerator.Generate(assignment)) {
-          var moveQuality = PTSPAnalyticalInsertionMoveEvaluator.EvaluateMove(assignment, move, distance, probabilities);
+          var moveQuality = PTSPAnalyticalInsertionMoveEvaluator.EvaluateMove(assignment, move, data);
           evaluations++;
           if (maximization && moveQuality > bestQuality
@@ -127,9 +120,8 @@
       var assignment = PermutationParameter.ActualValue;
       var maximization = MaximizationParameter.ActualValue.Value;
-      var distances = DistanceMatrixParameter.ActualValue;
       var quality = QualityParameter.ActualValue;
       var localIterations = LocalIterationsParameter.ActualValue;
       var evaluations = EvaluatedSolutionsParameter.ActualValue;
-      var probabilities = ProbabilitiesParameter.ActualValue;
+      var data = ProbabilisticTSPDataParameter.ActualValue;
       if (localIterations == null) {
         localIterations = new IntValue(0);
@@ -137,5 +129,5 @@
       }
 
-      Improve(assignment, distances, quality, localIterations, evaluations, maximization, maxIterations, probabilities, CancellationToken);
+      Improve(assignment, data, quality, localIterations, evaluations, maximization, maxIterations, CancellationToken);
 
       localIterations.Value = 0;
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/Improvers/PTSPAnalyticalInversionLocalImprovement.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/Improvers/PTSPAnalyticalInversionLocalImprovement.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/Improvers/PTSPAnalyticalInversionLocalImprovement.cs	(revision 17253)
@@ -22,4 +22,5 @@
 using System;
 using System.Threading;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -29,5 +30,4 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
 
 namespace HeuristicLab.Problems.PTSP {
@@ -39,5 +39,5 @@
   /// </remarks>
   [Item("PTSP Analytical Inversion Local Improvement", "An operator that improves probabilistic traveling salesman solutions. The operator tries to improve the probabilistic traveling salesman solution by swapping two randomly chosen edges for a certain number of times.")]
-  [StorableType("1594EB4E-A874-485A-B1D5-E622F9FF3FD8")]
+  [StorableType("88147d6a-e843-4f65-8058-421453b5206a")]
   public sealed class PTSPAnalyticalInversionLocalImprovement : SingleSuccessorOperator, IAnalyticalPTSPOperator, ILocalImprovementOperator {
 
@@ -70,10 +70,6 @@
     }
 
-    public ILookupParameter<DistanceMatrix> DistanceMatrixParameter {
-      get { return (ILookupParameter<DistanceMatrix>)Parameters["DistanceMatrix"]; }
-    }
-
-    public ILookupParameter<DoubleArray> ProbabilitiesParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters["Probabilities"]; }
+    public ILookupParameter<IProbabilisticTSPData> ProbabilisticTSPDataParameter {
+      get { return (ILookupParameter<IProbabilisticTSPData>)Parameters["PTSP Data"]; }
     }
 
@@ -90,6 +86,5 @@
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality value of the assignment."));
       Parameters.Add(new LookupParameter<BoolValue>("Maximization", "True if the problem should be maximized or minimized."));
-      Parameters.Add(new LookupParameter<DistanceMatrix>("DistanceMatrix", "The matrix which contains the distances between the cities."));
-      Parameters.Add(new LookupParameter<DoubleArray>("Probabilities", "The list of probabilities of the cities to appear."));
+      Parameters.Add(new LookupParameter<IProbabilisticTSPData>("PTSP Data", "The main parameters of the p-TSP."));
     }
 
@@ -98,7 +93,5 @@
     }
 
-    public static void Improve(Permutation assignment, DoubleMatrix distances, DoubleValue quality, IntValue localIterations, IntValue evaluatedSolutions, bool maximization, int maxIterations, DoubleArray probabilities, CancellationToken cancellation) {
-      var distanceM = (DistanceMatrix)distances;
-      Func<int, int, double> distance = (a, b) => distanceM[a, b];
+    public static void Improve(Permutation assignment, IProbabilisticTSPData data, DoubleValue quality, IntValue localIterations, IntValue evaluatedSolutions, bool maximization, int maxIterations, CancellationToken cancellation) {
       for (var i = localIterations.Value; i < maxIterations; i++) {
         InversionMove bestMove = null;
@@ -106,5 +99,5 @@
         var evaluations = 0.0;
         foreach (var move in ExhaustiveInversionMoveGenerator.Generate(assignment)) {
-          var moveQuality = PTSPAnalyticalInversionMoveEvaluator.EvaluateMove(assignment, move, distance, probabilities);
+          var moveQuality = PTSPAnalyticalInversionMoveEvaluator.EvaluateMove(assignment, move, data);
           evaluations++;
           if (maximization && moveQuality > bestQuality
@@ -127,9 +120,8 @@
       var assignment = PermutationParameter.ActualValue;
       var maximization = MaximizationParameter.ActualValue.Value;
-      var distances = DistanceMatrixParameter.ActualValue;
       var quality = QualityParameter.ActualValue;
       var localIterations = LocalIterationsParameter.ActualValue;
       var evaluations = EvaluatedSolutionsParameter.ActualValue;
-      var probabilities = ProbabilitiesParameter.ActualValue;
+      var data = ProbabilisticTSPDataParameter.ActualValue;
       if (localIterations == null) {
         localIterations = new IntValue(0);
@@ -137,5 +129,5 @@
       }
 
-      Improve(assignment, distances, quality, localIterations, evaluations, maximization, maxIterations, probabilities, CancellationToken);
+      Improve(assignment, data, quality, localIterations, evaluations, maximization, maxIterations, CancellationToken);
 
       localIterations.Value = 0;
